/**
  Generated main.c file from MPLAB Code Configurator

  @Company
    Microchip Technology Inc.

  @File Name
    main.c

  @Summary
    This is the generated main.c using PIC24 / dsPIC33 / PIC32MM MCUs.

  @Description
    This source file provides main entry point for system initialization and application code development.
    Generation Information :
        Product Revision  :  PIC24 / dsPIC33 / PIC32MM MCUs - 1.170.0
        Device            :  PIC24FJ64GA002
    The generated drivers are tested against the following:
        Compiler          :  XC16 v1.61
        MPLAB 	          :  MPLAB X v5.45
*/

/*
    (c) 2020 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

#define     FCY         32000000UL

/**
  Section: Included Files
*/
#include "mcc_generated_files/system.h"
#include <libpic30.h>

/*
                         Main application
 */

#define     LCD_RST     LATAbits.LATA4      //RA4
#define     LCD_CS      LATAbits.LATA0      //RA0
#define     LCD_WR      LATAbits.LATA1      //RA1
#define     LCD_DC      LATAbits.LATA2      //RA2
#define     LCD_RD      LATAbits.LATA3      //RA3

#define     LCD_D0      LATBbits.LATB8      //RB8
#define     LCD_D1      LATBbits.LATB9      //RB9
#define     LCD_D2      LATBbits.LATB10     //RB10
#define     LCD_D3      LATBbits.LATB11     //RB11
#define     LCD_D4      LATBbits.LATB12     //RB12
#define     LCD_D5      LATBbits.LATB13     //RB13
#define     LCD_D6      LATBbits.LATB14     //RB14
#define     LCD_D7      LATBbits.LATB15     //RB15

unsigned char disp_ram[7680];
unsigned char disp_moji[26];

unsigned char color_data1[15]={0,248,7,0,255,248,7,255,127,120,7,251,248,3,123};
unsigned char color_data2[15]={0,0,224,31,224,31,255,255,224,31,239,224,15,255,239};

unsigned char color_palet1[4]={7,1,3,0};

const unsigned char suji_font[10][288]={
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,85,84,0,1,85,85,85,85,64,5,106,170,170,169,80,5,170,170,170,170,80,
22,170,170,170,170,148,22,170,170,170,170,148,22,170,85,85,170,148,22,169,85,85,106,148,22,169,80,5,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,80,5,106,148,22,169,85,85,106,148,22,170,85,85,170,148,22,170,170,170,170,148,22,170,170,170,170,148,
5,170,170,170,170,80,5,106,170,170,169,80,1,85,85,85,85,64,0,21,85,85,84,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,84,0,0,1,85,85,85,0,0,5,106,170,165,0,0,5,170,170,165,0,0,
22,170,170,165,0,0,22,170,170,165,0,0,21,170,170,165,0,0,5,85,90,165,0,0,0,85,90,165,0,0,0,0,90,165,0,0,
0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,
0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,
0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,
0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,0,0,90,165,0,0,
0,0,90,165,0,0,0,1,90,165,64,0,5,85,90,165,85,80,21,85,106,169,85,84,22,170,170,170,170,148,22,170,170,170,170,148,
22,170,170,170,170,148,22,170,170,170,170,148,21,85,85,85,85,84,5,85,85,85,85,80,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,85,84,0,1,85,85,85,85,64,5,106,170,170,169,80,5,170,170,170,170,80,
22,170,170,170,170,148,22,170,170,170,170,148,22,170,85,85,170,148,22,169,85,85,106,148,22,169,80,5,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,21,85,64,1,106,148,5,85,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,5,106,148,0,21,85,85,106,148,1,85,85,85,170,148,5,106,170,170,170,148,5,170,170,170,170,148,
22,170,170,170,170,80,22,170,170,170,169,80,22,170,85,85,85,64,22,169,85,85,84,0,22,169,80,0,0,0,22,169,64,0,0,0,
22,169,64,0,0,0,22,169,64,0,0,0,22,169,64,0,0,0,22,169,64,0,0,0,22,169,64,0,0,0,22,169,64,0,0,0,
22,169,64,0,0,0,22,169,80,0,0,0,22,169,85,85,85,80,22,170,85,85,85,84,22,170,170,170,170,148,22,170,170,170,170,148,
5,170,170,170,170,148,5,106,170,170,170,148,1,85,85,85,85,84,0,21,85,85,85,80,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,85,84,0,1,85,85,85,85,64,5,106,170,170,169,80,5,170,170,170,170,80,
22,170,170,170,170,148,22,170,170,170,170,148,22,170,85,85,170,148,22,169,85,85,106,148,22,169,80,5,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,21,85,64,1,106,148,5,85,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,5,106,148,0,0,85,85,106,148,0,1,85,85,170,148,0,1,106,170,170,148,0,1,106,170,170,148,
0,1,106,170,170,148,0,1,106,170,170,148,0,1,85,85,170,148,0,0,85,85,106,148,0,0,0,5,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,5,85,0,1,106,148,21,85,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,80,5,106,148,22,169,85,85,106,148,22,170,85,85,170,148,22,170,170,170,170,148,22,170,170,170,170,148,
5,170,170,170,170,80,5,106,170,170,169,80,1,85,85,85,85,64,0,21,85,85,84,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,5,85,0,0,85,80,21,85,64,1,85,84,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,80,5,106,148,22,169,85,85,106,148,22,170,85,85,170,148,22,170,170,170,170,148,22,170,170,170,170,148,
5,170,170,170,170,148,5,106,170,170,170,148,1,85,85,85,170,148,0,21,85,85,106,148,0,0,0,5,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,85,84,0,0,0,0,85,80,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,85,85,80,1,85,85,85,85,84,5,106,170,170,170,148,5,170,170,170,170,148,
22,170,170,170,170,148,22,170,170,170,170,148,22,170,85,85,85,84,22,169,85,85,85,80,22,169,80,0,0,0,22,169,64,0,0,0,
22,169,64,0,0,0,22,169,64,0,0,0,22,169,64,0,0,0,22,169,64,0,0,0,22,169,64,0,0,0,22,169,64,0,0,0,
22,169,64,0,0,0,22,169,80,0,0,0,22,169,85,85,84,0,22,170,85,85,85,64,22,170,170,170,169,80,22,170,170,170,170,80,
5,170,170,170,170,148,5,106,170,170,170,148,1,85,85,85,170,148,0,21,85,85,106,148,0,0,0,5,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,5,85,0,1,106,148,21,85,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,80,5,106,148,22,169,85,85,106,148,22,170,85,85,170,148,22,170,170,170,170,148,22,170,170,170,170,148,
5,170,170,170,170,80,5,106,170,170,169,80,1,85,85,85,85,64,0,21,85,85,84,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,85,84,0,1,85,85,85,85,64,5,106,170,170,169,80,5,170,170,170,170,80,
22,170,170,170,170,148,22,170,170,170,170,148,22,170,85,85,170,148,22,169,85,85,106,148,22,169,80,5,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,85,84,22,169,64,0,85,80,22,169,64,0,0,0,22,169,64,0,0,0,
22,169,64,0,0,0,22,169,80,0,0,0,22,169,85,85,84,0,22,170,85,85,85,64,22,170,170,170,169,80,22,170,170,170,170,80,22,170,170,170,170,148,
22,170,170,170,170,148,22,170,85,85,170,148,22,169,85,85,106,148,22,169,80,5,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,80,5,106,148,22,169,85,85,106,148,22,170,85,85,170,148,22,170,170,170,170,148,22,170,170,170,170,148,5,170,170,170,170,80,
5,106,170,170,169,80,1,85,85,85,85,64,0,21,85,85,84,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,85,85,80,1,85,85,85,85,84,5,106,170,170,170,148,5,170,170,170,170,148,
22,170,170,170,170,148,22,170,170,170,170,148,22,170,85,85,106,148,22,169,85,85,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
21,85,64,1,106,148,5,85,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,0,0,0,1,85,84,0,0,0,0,85,80,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,85,84,0,1,85,85,85,85,64,5,106,170,170,169,80,5,170,170,170,170,80,
22,170,170,170,170,148,22,170,170,170,170,148,22,170,85,85,170,148,22,169,85,85,106,148,22,169,80,5,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,80,5,106,148,22,169,85,85,106,148,21,170,85,85,170,84,5,170,170,170,170,80,
1,106,170,170,169,64,1,106,170,170,169,64,5,170,170,170,170,80,21,170,85,85,170,84,22,169,85,85,106,148,22,169,80,5,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,80,5,106,148,22,169,85,85,106,148,22,170,85,85,170,148,22,170,170,170,170,148,
22,170,170,170,170,148,5,170,170,170,170,80,5,106,170,170,169,80,1,85,85,85,85,64,0,21,85,85,84,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,21,85,85,84,0,1,85,85,85,85,64,5,106,170,170,169,80,5,170,170,170,170,80,
22,170,170,170,170,148,22,170,170,170,170,148,22,170,85,85,170,148,22,169,85,85,106,148,22,169,80,5,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,80,5,106,148,22,169,85,85,106,148,22,170,85,85,170,148,22,170,170,170,170,148,22,170,170,170,170,148,
5,170,170,170,170,148,5,106,170,170,170,148,1,85,85,85,170,148,0,21,85,85,106,148,0,0,0,5,106,148,0,0,0,1,106,148,
0,0,0,1,106,148,0,0,0,1,106,148,5,85,0,1,106,148,21,85,64,1,106,148,22,169,64,1,106,148,22,169,64,1,106,148,
22,169,64,1,106,148,22,169,80,5,106,148,22,169,85,85,106,148,22,170,85,85,170,148,22,170,170,170,170,148,22,170,170,170,170,148,
5,170,170,170,170,80,5,106,170,170,169,80,1,85,85,85,85,64,0,21,85,85,84,0,0,0,0,0,0,0,0,0,0,0,0,0}
};

void    send_cmd(unsigned char cmd)
{
    unsigned int    data_p;
    
    LCD_DC=0;
    data_p=(unsigned int)cmd;
    LATB=data_p << 8;    
    LCD_WR=1;
    LCD_WR=0;
}

void    send_data(unsigned char data)
{
    unsigned int    data_p;
    
    LCD_DC=1;
    data_p=(unsigned int)data;
    LATB=data_p << 8;    
    LCD_WR=1;
    LCD_WR=0;
}

void    send_data_2(unsigned char data1,unsigned char data2)
{
    unsigned int    data_p;
    
    LCD_DC=1;
    data_p=(unsigned int)data1;
    LATB=data_p << 8;
    LCD_WR=1;
    LCD_WR=0;
    data_p=(unsigned int)data2;
    LATB=data_p << 8;
    LCD_WR=1;
    LCD_WR=0;    
}

void    send_data_4(unsigned char data1,unsigned char data2,unsigned char data3,unsigned char data4)
{
    unsigned int    data_p;
    
    LCD_DC=1;
    data_p=(unsigned int)data1;
    LATB=data_p << 8;
    LCD_WR=1;
    LCD_WR=0;
    data_p=(unsigned int)data2;
    LATB=data_p << 8;
    LCD_WR=1;
    LCD_WR=0;
    data_p=(unsigned int)data3;
    LATB=data_p << 8;
    LCD_WR=1;
    LCD_WR=0;
    data_p=(unsigned int)data4;
    LATB=data_p << 8;
    LCD_WR=1;
    LCD_WR=0;    
}

void    disp_ram_clear(void)
{
    unsigned int    i;
    
    for(i=0;i<7680;i++){
        disp_ram[i]=0;
    }
}
void    disp_ram_set(void)
{
    unsigned int    i,j,x,y;
    unsigned char   n;
    
    for(j=0;j<26;j++){
        n=disp_moji[j];
        
        for(y=0;y<48;y++){
            for(x=0;x<6;x++){
                i=j*6+y*160+x;
                disp_ram[i]=suji_font[n][y*6+x];
            }
        }
    }
}

void    disp_moji_set(void)
{
    disp_moji[0]=0;
    disp_moji[1]=1;
    disp_moji[2]=2;
    disp_moji[3]=3;
    disp_moji[4]=4;
    disp_moji[5]=5;
    disp_moji[6]=6;
    disp_moji[7]=7;
    disp_moji[8]=8;
    disp_moji[9]=9;
    disp_moji[10]=0;
    disp_moji[11]=1;
    disp_moji[12]=2;
    disp_moji[13]=3;
    disp_moji[14]=4;
    disp_moji[15]=5;
    disp_moji[16]=6;
    disp_moji[17]=7;
    disp_moji[18]=8;
    disp_moji[19]=9;
    disp_moji[20]=0;
    disp_moji[21]=1;
    disp_moji[22]=2;
    disp_moji[23]=3;
    disp_moji[24]=4;
    disp_moji[25]=5;
    
}
void    set_up(void)
{
    LCD_WR=0;
    LCD_RD=1;
    LCD_RST=0;
    __delay_ms(10);
    LCD_RST=1;
    __delay_ms(10);
    LCD_CS=0;
    
    send_cmd(0xc8);
    send_data(0xff);
    send_data(0x93);
    send_data(0x42);
    
    send_cmd(0x2a);
    send_data_4(0x00,0x00,0x01,0x3f);
    
    send_cmd(0x2b);
    send_data_4(0x00,0x00,0x00,0x5f);

    send_cmd(0x36);
    send_data(0xc8);

    send_cmd(0xc0);
    send_data(0x0e);
    send_data(0x0e);

    send_cmd(0xc1);
    send_data(0x10);

    send_cmd(0xc5);
    send_data(0xfa);

    send_cmd(0x3a);
    send_data(0x55);

    send_cmd(0xb1);
    send_data(0x00);
    send_data(0x18);

    send_cmd(0xe0);
    send_data(0x00);
    send_data(0x1c);
    send_data(0x21);
    send_data(0x02);
    send_data(0x11);
    send_data(0x07);
    send_data(0x3d);
    send_data(0x79);
    send_data(0x4b);
    send_data(0x07);
    send_data(0x0f);
    send_data(0x0c);
    send_data(0x1b);
    send_data(0x1f);
    send_data(0x0f);

    send_cmd(0xe1);
    send_data(0x00);
    send_data(0x1c);
    send_data(0x20);
    send_data(0x04);
    send_data(0x0f);
    send_data(0x04);
    send_data(0x33);
    send_data(0x45);
    send_data(0x42);
    send_data(0x04);
    send_data(0x0c);
    send_data(0x0a);
    send_data(0x22);
    send_data(0x29);
    send_data(0x0f);

    send_cmd(0x11);
    __delay_ms(130);

    send_cmd(0x29);
    __delay_ms(10);
    
}
void    disp_clear(void)
{
    unsigned int    i;
    
    send_cmd(0x2a);
    send_data_4(0x00,0x00,0x01,0x3f);
    send_cmd(0x2b);
    send_data_4(0x00,0x00,0x00,0x5f);
    send_cmd(0x2c);

    for (i = 0; i < 30720; i++)
    {
        send_data_2(0x00,0x00);
    }    
}
void    test_lcd(void){
    unsigned int    i,x;
    unsigned char   n;
    
    send_cmd(0x2a);
    send_data_4(0x00,0x00,0x01,0x3f);
    send_cmd(0x2b);
    send_data_4(0x00,0x00,0x00,0x5f);
    send_cmd(0x2c);
    
    x=0;
    for (i = 0;i < 30720; i++){
        n=(unsigned char)(x/46)+1;
        if (x >= 639){
            x = 0;
        }
        else{
            x++;
        }
        send_data_2(color_data1[n],color_data2[n]);
    }    
}
void    disp_main(void)
{
    unsigned int    i;
    unsigned char   data0,data1,data2,data3,data4;

    send_cmd(0x2a);
    send_data_4(0x00,0x00,0x01,0x3f);
    send_cmd(0x2b);
    send_data_4(0x00,0x00,0x00,0x5f);
    send_cmd(0x2c);
    
    for (i=0;i<7680;i++){
        data0=disp_ram[i];
        data1=color_palet1[((data0 >> 6) & 0x03)];
        data2=color_palet1[((data0 >> 4) & 0x03)];
        data3=color_palet1[((data0 >> 2) & 0x03)];
        data4=color_palet1[(data0 & 0x03)];
        
        send_data_4(color_data1[data1],color_data2[data1],color_data1[data2],color_data2[data2]);
        send_data_4(color_data1[data3],color_data2[data3],color_data1[data4],color_data2[data4]);        
        
    }
}
int main(void)
{
    // initialize the device
    SYSTEM_Initialize();
    
    set_up();
    disp_clear();
    test_lcd();
    __delay_ms(1000);
    
    disp_ram_clear();
    disp_moji_set();
    disp_ram_set();
    
    disp_main();
    
    while (1)
    {
        // Add your application code
    }

    return 1;
}
/**
 End of File
*/

